/*
    Romaji to Hiragana Translator
    Copyright (C) 2009  Douglas S. Goodwin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#define WINVER          0x0600
#define _WIN32_IE       0x0600
#include <windows.h>
#include "main.h"
#include "meta.h"


LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

int WINAPI
WinMain(HINSTANCE hInst,
        HINSTANCE hPrevInst,
        LPSTR szArg,
        INT iArg){
    
    WNDCLASS wc;
    HWND hwnd;
    MSG msg;
    LPSTR szName="Romaji to Kana Translator";
    
    wc.hInstance=hInst;
    wc.hIcon=LoadIcon(NULL, IDI_APPLICATION);
    wc.hCursor=LoadCursor(NULL, IDC_IBEAM);
    wc.cbClsExtra=0;
    wc.cbWndExtra=0;
    wc.lpfnWndProc=WindowProcedure;
    wc.lpszClassName=szName;
    wc.lpszMenuName=NULL;
    wc.hbrBackground=(HBRUSH)COLOR_WINDOW;
    wc.style=0;

    RegisterClass(&wc);
    
    hwnd=CreateWindow(szName, szName,
            WS_SYSMENU|WS_MAXIMIZEBOX|WS_MINIMIZEBOX|WS_SIZEBOX|WS_CAPTION,
            CW_USEDEFAULT, CW_USEDEFAULT, 500, 500,
            NULL, NULL, hInst, NULL);

    ShowWindow(hwnd, iArg);

    while(GetMessage(&msg, hwnd, 0, 0)>0){
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return 0;
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam){
    switch(msg){
        case WM_CREATE:
            HWND edit;
            HMENU menu,submenu;
            
            ZeroMemory(&ofn, sizeof(ofn));

            text=new wchar_t[0xffff];
            newText=new wchar_t[0xffff];

            ofn.lStructSize=sizeof(ofn);
            ofn.hInstance=(HINSTANCE)NULL;
            ofn.hwndOwner=hwnd;
            ofn.lpstrFilter=("Text Files(.txt)\0*.txt\0All Files(*.*)\0*.*\0\0");
            ofn.lpstrDefExt=("txt");
            ofn.nFilterIndex=1;
            ofn.lpstrInitialDir=("%USERPROFILE%/Documents");
            ofn.lpstrFile=szFileName;
            ofn.nMaxFile=MAX_PATH;

            pdlg.lStructSize=sizeof(pdlg);
            pdlg.hDC=0;
            
            menu=CreateMenu();

            submenu=CreatePopupMenu();
            AppendMenu(submenu, MF_STRING, IDM_OPEN, "&Open");
            AppendMenu(submenu, MF_STRING, IDM_SAVE, "&Save");
            AppendMenu(submenu, MF_SEPARATOR, 0, 0);
            AppendMenu(submenu, MF_STRING, IDM_PRINT, "&Print");
            AppendMenu(submenu, MF_SEPARATOR, 0, 0);
            AppendMenu(submenu, MF_STRING, IDM_EXIT, "E&xit");
            AppendMenu(menu, MF_POPUP|MF_STRING, (UINT)submenu, "&File");

            submenu=CreatePopupMenu();
            AppendMenu(submenu, MF_STRING, IDM_PARSE_ALL2HIRAGANA, "Parse All To Hiragana");
            AppendMenu(submenu, MF_STRING, IDM_PARSE_ALL2KATAKANA, "Parse All To Katakana");
            AppendMenu(submenu, MF_SEPARATOR,0,0);
            AppendMenu(submenu, MF_STRING, IDM_PARSE_SEL2HIRAGANA, "Parse Selection To Hiragana");
            AppendMenu(submenu, MF_STRING, IDM_PARSE_SEL2KATAKANA, "Parse Selection To Katakana");
            AppendMenu(menu, MF_POPUP|MF_STRING, (UINT)submenu, "&Control");
            
            submenu=CreatePopupMenu();
            AppendMenu(submenu, MF_STRING, IDM_ABOUT, "&About");
            AppendMenu(menu, MF_POPUP|MF_STRING, (UINT)submenu, "&Help");
            
            SetMenu(hwnd, menu);
            CreateWindowExW(WS_EX_CLIENTEDGE,L"EDIT",L"\0",
                    ES_MULTILINE|WS_VISIBLE|WS_VSCROLL|WS_CHILD|ES_LEFT|ES_WANTRETURN,
                    5,5,460,460,
                    hwnd, (HMENU)IDE_EDIT, NULL,NULL);
            HDC dc=GetDC(GetDlgItem(hwnd,IDE_EDIT));
            font=CreateFont(-MulDiv(18,GetDeviceCaps(dc,LOGPIXELSY),72),0,0,0,0,0,0,0,0,0,0,0,0,"Microsoft JhengHei");
            ReleaseDC(GetDlgItem(hwnd,IDE_EDIT),dc);
            SendDlgItemMessage(hwnd, IDE_EDIT, WM_SETFONT, (WPARAM)font, true);
            return 0;
        case WM_COMMAND:
            switch(LOWORD(wParam)){
                case IDM_EXIT:
                    goto exit;
                case IDM_OPEN:
                    Open(hwnd);
                    return 0;
                case IDM_SAVE:
                    Save(hwnd);
                    return 0;
                case IDM_PRINT:
                    pdlg.Flags=PD_RETURNDC|PD_PRINTSETUP;
                    if(PrintDlgW(&pdlg))
                        PrintContents(GetDlgItem(hwnd,IDE_EDIT));
                    return 0;
                case IDM_ABOUT:
                    MessageBox(hwnd, 
                            "Author: Douglas Goodwin\n"
                            "Version: 3.0\n",
                            "About Romaji to Kana Translator",
                            MB_OK|MB_ICONINFORMATION);
                    return 0;
                case IDM_PARSE_ALL2HIRAGANA:
                    length=GetWindowTextLengthW(GetDlgItem(hwnd, IDE_EDIT))+1;
                    GetDlgItemTextW(hwnd, IDE_EDIT, text, length);
                    Romaji2Kana(length,false);
                    SetWindowTextW(GetDlgItem(hwnd, IDE_EDIT), newText);
                    return 0;
                case IDM_PARSE_ALL2KATAKANA:
                    length=GetWindowTextLengthW(GetDlgItem(hwnd, IDE_EDIT))+1;
                    GetDlgItemTextW(hwnd, IDE_EDIT, text, length);
                    Romaji2Kana(length,true);
                    SetWindowTextW(GetDlgItem(hwnd, IDE_EDIT), newText);
                    return 0;
                case IDM_PARSE_SEL2HIRAGANA:
                    length=GetWindowTextLengthW(GetDlgItem(hwnd, IDE_EDIT))+1;
                    SendDlgItemMessageW(hwnd, IDE_EDIT,EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
                    GetDlgItemTextW(hwnd, IDE_EDIT, text, length);
                    Romaji2Kana(end,false, start);
                    SendDlgItemMessageW(hwnd,IDE_EDIT,EM_REPLACESEL,0,(LPARAM)newText);
                    break;
                case IDM_PARSE_SEL2KATAKANA:
                    length=GetWindowTextLengthW(GetDlgItem(hwnd, IDE_EDIT))+1;
                    SendDlgItemMessageW(hwnd, IDE_EDIT,EM_GETSEL, (WPARAM)&start, (LPARAM)&end);
                    GetDlgItemTextW(hwnd, IDE_EDIT, text, length);
                    Romaji2Kana(end,true, start);
                    newText[end+1]=0;
                    SendDlgItemMessageW(hwnd,IDE_EDIT,EM_REPLACESEL,0,(LPARAM)newText);
                    break;
            }
                        
            return 0;
        case WM_SIZE:
            SetWindowPos(GetDlgItem(hwnd, IDE_EDIT),0, 0,0, LOWORD(lParam), HIWORD(lParam), SWP_SHOWWINDOW);
            return 0;
        case WM_DESTROY:
            exit:
            delete text, newText;
            DeleteObject(font);
            PostQuitMessage(0);
            return 0;
        default:
            return DefWindowProc(hwnd, msg, wParam, lParam);
    }
    return 0;
}
