/*
    Romaji to Hiragana Translator
    Copyright (C) 2009  Douglas S. Goodwin

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef _MAIN_H
#define	_MAIN_H

#define IDE_EDIT                10
#define IDM_EXIT                100
#define IDM_OPEN                200
#define IDM_SAVE                300
#define IDM_ABOUT               500
#define IDM_PARSE_ALL2HIRAGANA  600
#define IDM_PARSE_ALL2KATAKANA  700
#define IDM_PARSE_SEL2HIRAGANA  800
#define IDM_PARSE_SEL2KATAKANA  900
#define IDM_PRINT               1000


HFONT font;
OPENFILENAME ofn;
HANDLE hFile;
PRINTDLGW pdlg={0};

char szFileName[MAX_PATH];
wchar_t* text;
wchar_t* newText;
int length;
int start;
int end;

void PrintContents(HWND hwnd){
    TEXTMETRICW tm;
    DOCINFO di={0};
    HFONT pFont=CreateFont(180,0,0,0,0,0,0,0,0,0,0,0,0,"Microsoft JhengHei");
    SIZE sz;
    
    SelectObject(pdlg.hDC,pFont);
    GetTextMetricsW(pdlg.hDC, &tm);
    GetWindowTextW(hwnd,text,GetWindowTextLengthW(hwnd)+1);

    int width=GetDeviceCaps(pdlg.hDC, HORZRES);
    int nLines=GetDeviceCaps(pdlg.hDC, VERTRES)/tm.tmHeight;
    int outX=GetDeviceCaps(pdlg.hDC,PHYSICALWIDTH)-width;
    int l=1;
    int cl=0;
    wchar_t out[100];

    di.cbSize=sizeof(di);
    di.fwType=0;
    di.lpszDocName="Romaji to Kana Text";
    di.lpszDatatype=NULL;

    StartDoc(pdlg.hDC, &di); 
    StartPage(pdlg.hDC);
    for(int c=0;c<GetWindowTextLengthW(hwnd)+1;c++,cl++){
        
        out[cl]=text[c];
        GetTextExtentPoint32W(pdlg.hDC,out,cl+1,&sz);

        if(text[c]==L'\n'||sz.cx+tm.tmMaxCharWidth*2>width-outX){
            TextOutW(pdlg.hDC,outX,sz.cy*l,out,cl+1);
            
            l+=1;   cl=0;
            memset(out,0,sizeof(wchar_t)*100);
            if(l>nLines){
                EndPage(pdlg.hDC);
                StartPage(pdlg.hDC);
                l=1;
            }
        }
        
    }
    TextOutW(pdlg.hDC,outX,sz.cy*(l),out,cl+1);
    EndPage(pdlg.hDC);
    EndDoc(pdlg.hDC);
    
    DeleteDC(pdlg.hDC);
    DeleteObject(pFont);
}
void Open(HWND hwnd){
    szFileName[0]=0;
    ofn.Flags=OFN_EXPLORER|OFN_OVERWRITEPROMPT;

    if(GetOpenFileName(&ofn)){
        hFile=CreateFile(szFileName,GENERIC_READ, FILE_SHARE_READ,0,OPEN_EXISTING,0, 0);

        if(hFile!=INVALID_HANDLE_VALUE){
            int fsize=GetFileSize(hFile, 0);
            unsigned long read;
            SetFilePointer(hFile, 2,NULL,0);
            ReadFile(hFile,text,fsize, &read, 0);
            text[fsize/2]=0;
            SetDlgItemTextW(hwnd, IDE_EDIT, text);
            CloseHandle(hFile);
        }
    }
}
void Save(HWND hwnd){
szFileName[0]=0;

    ofn.Flags=OFN_EXPLORER|OFN_OVERWRITEPROMPT;

    if(GetSaveFileName(&ofn))
        hFile=CreateFile(szFileName,GENERIC_WRITE, 0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL, 0);
        if(hFile!=INVALID_HANDLE_VALUE){
            int len=GetWindowTextLengthW(GetDlgItem(hwnd, IDE_EDIT));
            GetDlgItemTextW(hwnd, IDE_EDIT, text, len+1);
            DWORD write;
            wchar_t mark[1];
            mark[0]=0xfeff;
            WriteFile(hFile,mark, sizeof(wchar_t), &write,0);
            SetFilePointer(hFile, 2, NULL, 0);
            WriteFile(hFile, text,len*sizeof(wchar_t),&write,0);
            CloseHandle(hFile);
        }
}

void Romaji2Kana(int length, bool katakana,int start=0){
    
    int n=0;
    int id=0;
    int cs;
    bool doCheck=false;
    bool isNsingle=true;
    
    //char range between 12,353 to 12,437
    for(int i=start;i<length;i+=1){
        cs=int(text[i]);
        switch(cs){
            case 97:
                A:
                switch (id){

                    case 0:
                        newText[n]=katakana?12450:12354;//id=0, a
                        break;
                    case 1:
                        newText[n]=katakana?12459:12363;//id=1, ka
                        break;
                    case 2:
                        newText[n]=katakana?12460:12364;//id=2, ga
                        break;
                    case 3:
                        newText[n]=katakana?12469:12373;//id=3, sa
                        break;
                    case 4:
                        newText[n]=katakana?12470:12374;//id=4, za
                        break;
                    case 5:
                        newText[n]=katakana?12479:12383;//id=5, ta
                        break;
                    case 6:
                        newText[n]=katakana?12480:12384;//id=6, da
                        break;
                    case 7:
                        newText[n]=katakana?12490:12394;//id=7, na
                        break;
                    case 8:
                        newText[n]=katakana?12495:12399;//id=8, ha
                        break;
                    case 9:
                        newText[n]=katakana?12496:12400;//id=9, ba
                        break;
                    case 10:
                        newText[n]=katakana?12497:12401;//id=10, pa
                        break;
                    case 11:
                        newText[n]=katakana?12510:12414;//id=11, ma
                        break;
                    case 12:
                        newText[n]=katakana?12521:12425;//id=12, ra
                        break;
                    case 13:
                        newText[n]=katakana?12516:12420;//id=13, ya

                        break;
                    case 14:
                        newText[n]=katakana?12527:12431;//id=14, wa
                        break;
                }
                id=0;
                n+=1;
                continue;
            case 65:
                goto A;
            case 105:
                I:
                switch (id){

                    case 0:
                        newText[n]=katakana?12452:12356;//id=0, i
                        break;
                    case 1:
                        newText[n]=katakana?12461:12365;//id=1, ki
                        break;
                    case 2:
                        newText[n]=katakana?12462:12366;//id=2, gi
                        break;
                    case 3:
                        newText[n]=katakana?12471:12375;//id=3, shi
                        break;
                    case 4:
                        newText[n]=katakana?12472:12376;//id=4, ji
                        break;
                    case 5:
                        newText[n]=katakana?12481:12385;//id=5, chi
                        break;
                    case 6:
                        newText[n]=katakana?12482:12386;//id=6, ji
                        break;
                    case 7:
                        newText[n]=katakana?12491:12395;//id=7, ni
                        break;
                    case 8:
                        newText[n]=katakana?12498:12402;//id=8, hi
                        break;
                    case 9:
                        newText[n]=katakana?12499:12403;//id=9, bi
                        break;
                    case 10:
                        newText[n]=katakana?12500:12404;//id=10, pi
                        break;
                    case 11:
                        newText[n]=katakana?12511:12415;//id=11, mi
                        break;
                    case 12:
                        newText[n]=katakana?12522:12426;//id=12, ri
                        break;
                }
                id=0;
                n+=1;
                if(doCheck)
                    goto check;
                continue;
            case 73:
                goto I;
            case 117:
                U:
                switch (id){

                    case 0:
                        newText[n]=katakana?12454:12358;//id=0, u
                        break;
                    case 1:
                        newText[n]=katakana?12463:12367;//id=1, ku
                        break;
                    case 2:
                        newText[n]=katakana?12464:12368;//id=2, gu
                        break;
                    case 3:
                        newText[n]=katakana?12473:12377;//id=3, su
                        break;
                    case 4:
                        newText[n]=katakana?12474:12378;//id=4, zu
                        break;
                    case 5:
                        repeat:
                        newText[n]=katakana?12484:12388;//id=5, tsu
                        break;
                    case 6:
                        newText[n]=katakana?12485:12389;//id=6, zu
                        break;
                    case 7:
                        newText[n]=katakana?12492:12396;//id=7, nu
                        break;
                    case 8:
                        newText[n]=katakana?12501:12405;//id=8, fu
                        break;
                    case 9:
                        newText[n]=katakana?12502:12406;//id=9, bu
                        break;
                    case 10:
                        newText[n]=katakana?12503:12407;//id=10, pu
                        break;
                    case 11:
                        newText[n]=katakana?12512:12416;//id=11, mu
                        break;
                    case 12:
                        newText[n]=katakana?12523:12427;//id=12, ru
                        break;
                    case 13:
                        newText[n]=katakana?12518:12422;//id=13, yu
                        break;
                }
                id=0;
                n+=1;
                continue;

            case 85:
                goto U;
            case 101:
                E:
                switch (id){

                    case 0:
                        newText[n]=katakana?12456:12360;//id=0, e
                        break;
                    case 1:
                        newText[n]=katakana?12465:12369;//id=1, ke
                        break;
                    case 2:
                        newText[n]=katakana?12466:12370;//id=2, ge
                        break;
                    case 3:
                        newText[n]=katakana?12475:12379;//id=3, se
                        break;
                    case 4:
                        newText[n]=katakana?12476:12380;//id=4, ze
                        break;
                    case 5:
                        newText[n]=katakana?12486:12390;//id=5, te
                        break;
                    case 6:
                        newText[n]=katakana?12487:12391;//id=6, de
                        break;
                    case 7:
                        newText[n]=katakana?12493:12400;//id=7, ne
                        break;
                    case 8:
                        newText[n]=katakana?12504:12408;//id=8, he
                        break;
                    case 9:
                        newText[n]=katakana?12505:12409;//id=9, be
                        break;
                    case 10:
                        newText[n]=katakana?12506:12410;//id=10, pe
                        break;
                    case 11:
                        newText[n]=katakana?12513:12417;//id=11, me
                        break;
                    case 12:
                        newText[n]=katakana?12524:12431;//id=12, re
                        break;
                }
                id=0;
                n+=1;
                continue;
            case 69:
                goto E;
            case 111:
                O:
                switch (id){

                    case 0:
                        newText[n]=katakana?12458:12362;//id=0, o
                        break;
                    case 1:
                        newText[n]=katakana?12467:12371;//id=1, ko
                        break;
                    case 2:
                        newText[n]=katakana?12468:12372;//id=2, go
                        break;
                    case 3:
                        newText[n]=katakana?12477:12381;//id=3, so
                        break;
                    case 4:
                        newText[n]=katakana?12478:12382;//id=4, zo
                        break;
                    case 5:
                        newText[n]=katakana?12488:12392;//id=5, to
                        break;
                    case 6:
                        newText[n]=katakana?12489:12393;//id=6, do
                        break;
                    case 7:
                        newText[n]=katakana?12494:12398;//id=7, no
                        break;
                    case 8:
                        newText[n]=katakana?12507:12411;//id=8, ho

                        break;
                    case 9:
                        newText[n]=katakana?12508:12412;//id=9, bo
                        break;
                    case 10:
                        newText[n]=katakana?12509:12413;//id=10, po
                        break;
                    case 11:
                        newText[n]=katakana?12514:12418;//id=11, mo
                        break;
                    case 12:
                        newText[n]=katakana?12525:12429;//id=12, ro

                        break;
                    case 13:
                        newText[n]=katakana?12520:12424;//id=11, yo
                        break;
                    case 14:
                        newText[n]=katakana?12530:12434;//id=12, wo
                        break;
                }
                id=0;
                n+=1;
                continue;
            case 79:
                goto O;
            case 98:
                B:
                id=9;
                continue;
            case 66:
                goto B;

            case 100:
                D:

                id=6;
                continue;
            case 68:
                goto D;
            case 102:
                goto H;
            case 70:
                goto H;
            case 99:

                goto T;
            case 103:
                G:

                id=2;
                continue;
            case 71:
                goto G;
            case 104:
                H:
                if((text[i+1]==97||text[i+1]==65||
                   text[i+1]==111||text[i+1]==79||
                   text[i+1]==117||text[i+1]==85)&&
                        (text[i-1]==83||text[i-1]==115
                        ||text[i-1]==67||text[i-1]==99))
                {
                    goto Y;}

                if(text[i-1]==83||text[i-1]==115
                        ||text[i-1]==67||text[i-1]==99)
                    continue;
                id=8;
                continue;
            case 72:
                goto H;
            case 106:
                if((
                        text[i+1]==97||text[i+1]==65||
                        text[i+1]==79||text[i+1]==111||
                        text[i+1]==117||text[i+1]==85))
                {
                    id=0;
                    newText[n]=katakana?12472:12376;//id=4, ji
                    n+=1;
                    goto check;
                }
                goto Z;
            case 107:
                K:
                if(text[i]==text[i+1]&&(
                    text[i+1]!=97&&text[i+1]!=101&&text[i+1]!=105&&
                    text[i+1]!=111&&text[i+1]!=117&&
                    text[i+1]!=65&&text[i+1]!=69&&text[i+1]!=73&&
                    text[i+1]!=79&&text[i+1]!=85))
                    goto repeat;
                id=1;
                continue;
            case 75:
                goto K;
            case 109:
                M:

                id=11;
                continue;
            case 77:
                goto M;
            case 110:
                N:
                if(text[i+1]!=97&&text[i+1]!=101&&text[i+1]!=105&&
                        text[i+1]!=111&&text[i+1]!=117&&
                        text[i+1]!=65&&text[i+1]!=69&&text[i+1]!=73&&
                        text[i+1]!=79&&text[i+1]!=85&&!(text[i+1]==39||
                        text[i+1]==89||text[i+1]==121)){
                    newText[n]=katakana?12531:12435;
                    isNsingle=true;
                    id=7;
                    n+=1;
                    continue;
                }
                else if(text[i+1]==39){
                    isNsingle=false;
                    id=13;
                    newText[n]=katakana?12531:12435;
                    n+=1;
                    continue;
                }
                id=7;
                continue;
            case 78:

                goto N;
            case 112:
                P:
                if(text[i]==text[i+1]&&(
                    text[i+1]!=97&&text[i+1]!=101&&text[i+1]!=105&&
                    text[i+1]!=111&&text[i+1]!=117&&
                    text[i+1]!=65&&text[i+1]!=69&&text[i+1]!=73&&
                    text[i+1]!=79&&text[i+1]!=85&&text[i+1]!=121&&
                    text[i+1]!=89))
                    goto repeat;
                id=10;
                continue;
            case 80:
                goto P;
            case 114:
                R:
                id=12;
                continue;
            case 82:
                goto R;
            case 115:
                S:

                if(text[i]==text[i+1]&&(
                    text[i+1]!=97&&text[i+1]!=101&&text[i+1]!=105&&
                    text[i+1]!=111&&text[i+1]!=117&&
                    text[i+1]!=65&&text[i+1]!=69&&text[i+1]!=73&&
                    text[i+1]!=79&&text[i+1]!=85))
                    goto repeat;
                if(text[i-1]==116||text[i-1]==84)
                    continue;
                if(text[i+1]==104||text[i+1]==72)
                    i+=1;
                id=3;
                continue;
            case 83:
                goto S;
            case 116:
                T:
                if(text[i]==text[i+1]&&(
                    text[i+1]!=97&&text[i+1]!=101&&text[i+1]!=105&&
                    text[i+1]!=111&&text[i+1]!=117&&
                    text[i+1]!=65&&text[i+1]!=69&&text[i+1]!=73&&
                    text[i+1]!=79&&text[i+1]!=85))
                    goto repeat;

                id=5;

                continue;
            case 84:
                goto T;
            case 119:
                W:

                id=14;
                continue;
            case 87:
                goto W;
            case 121:
                Y:
                doCheck=true;
                if(text[i-1]==115||text[i-1]==85){//s
                    id=3;
                    goto I;
                }
                else if(text[i-1]==99||text[i-1]==67){//c *
                    id=5;
                    goto I;
                }
                else if(text[i-1]==98||text[i-1]==66){//b
                    id=9;
                    goto I;
                }
                else if(text[i-1]==104||text[i-1]==72){//h
                    id=8;
                    goto I;
                }
                else if(text[i-1]==109||text[i-1]==77){//m
                    id=11;
                    goto I;
                }
                else if(text[i-1]==107||text[i-1]==75){//k
                    id=1;
                    goto I;
                }

                else if(text[i-1]==103||text[i-1]==71){//g
                    id=2;
                    goto I;
                }
                else if((text[i-1]==110||text[i-1]==78)&&isNsingle){//n
                    id=7;
                    isNsingle=false;
                    goto I;
                }
                else if(text[i-1]==112||text[i-1]==80){//p
                    id=1;
                    goto I;
                }
                else if(text[i-1]==114||text[i-1]==82){//r
                    id=12;
                    goto I;
                }
                else if(text[i-1]==121||text[i-1]==89)
                {
                    doCheck=false;

                }
                id=13;
                doCheck=false;
                continue;
                check:
                doCheck=false;
                switch((int)text[i+1]){
                    case 97: //a
                        newText[n]=katakana?12515:12419;n+=1;
                        break;
                    case 65://A
                        newText[n]=katakana?12515:12419;n+=1;
                        break;
                    case 117://u
                        newText[n]=katakana?12517:12421;n+=1;
                        break;
                    case 85://U
                        newText[n]=katakana?12517:12421;n+=1;
                        break;
                    case 111://o
                        newText[n]=katakana?12519:12423;n+=1;
                        break;
                    case 79://O
                        newText[n]=katakana?12519:12423;
                        n+=1;
                        break;
                }
                i+=1;
                continue;
            case 89:
                goto Y;
            case 122:
                Z:
                id=4;

                continue;
            case 90:
                goto Z;
            case 39:
                continue;
            default:
                newText[n]=cs;
                n+=1;

        }

    }
    newText[n]=0;
}
#endif	/* _MAIN_H */

